/*
 * Ambient - the ultimate desktop
 * ------------------------------
 * Copyright 2001-2005 by David Gerber <zapek@morphos.net>
 * Copyright 2005-2006 Ambient Open Source Team
 * All Rights Reserved
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 *
 * $Id: panelbookmarksclass.c,v 1.1 2007/07/08 20:56:41 fab Exp $
 */

#include "ambient.h"

/* public */
#include <cybergraphx/cybergraphics.h>
#include <graphics/rpattr.h>
#include <proto/cybergraphics.h>
#include <proto/graphics.h>

/* private */
#include "mui_func.h"
#include "ambient_cat.h"
#include "rexx.h"
#include "command.h"
#include "contextmenu.h"
#include "bookmarks.h"
#include "name.h"
#include "prefs.h"
#include "methodstack.h"

struct Data {
	APTR   cmenu;
};

DEFNEW
{
	obj = DoSuperNew(cl, obj,
		MA_PanelPopup_IconType, MV_Icon_Type_Bookmarks,
		MA_PanelPopup_MenuTitle, GSI(MSG_CMENUTITLE_PANELPOPUPBOOKMARKS),
		TAG_DONE
	);

	return ((ULONG)obj);
}

DEFDISP
{
	GETDATA;
	return DOSUPER;
}

DEFTMETHOD(PanelPopup_Popup)
{
	GETDATA;

	APTR menustrip, menu, rc;
	ULONG type;

	menustrip = bookmarks_buildmenuobj(-1);

	//kprintf("menustrip:%d\n",menustrip);

	if (menustrip != NULL)
	{
		rc = (APTR)DoMethod(menustrip, MUIM_Menustrip_Popup, obj, 0 , _left(obj),_bottom(obj)-1);

		if (rc != NULL)
			contextmenu_execute(NULL, NULL, rc, FALSE);

		MUI_DisposeObject(menustrip);

	}

	return (0);
}

DEFGET
{
	GETDATA;

	switch (msg->opg_AttrID)
	{
		case MA_Panel_Type:
			*msg->opg_Storage = MV_Panel_Type_Bookmarks;
			return (TRUE);
			break;
	}

	return DOSUPER;
}

BEGINMTABLE
DECNEW
DECDISP
DECGET
DECTMETHOD(PanelPopup_Popup)
ENDMTABLE

DECSUBCLASSPTR_NC(panelpopupclass, panelbookmarksclass)

